<?php
// $Id: xc_search_facet_date_field.php,v 1.1.2.6 2010/06/01 15:03:43 pkiraly Exp $

function xc_search_facet_date_field_form(&$form_state, $facet) {
  
  $schema = drupal_get_schema_unprocessed('xc_search', 'xc_search_facet_field');
  drupal_set_title($schema['description']);
  $options = array(
    'omit' => array('field_id'),
    'hidden' => array(
      'facet_id' => $facet->facet_id,
      'type'     => 'date',
    ),
    'select' => array(
      'attribute_set_id' => array(),
      'name' => array(),
    ),
  );
  $sql = "SELECT set_id, name, description FROM {xc_search_date_facet_properties}";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_date_facet_properties}',
    'set_id'));
  while ($data = db_fetch_object($result)) {
    $options['select']['attribute_set_id'][$data->set_id] =  $data->name;
  }
  $options['select']['name'] = array_merge(
    xc_search_facet_mapping_get_facets($facet->metadata_schema, TRUE),
    xc_format_get_fields($facet->metadata_schema)
  );
  
  /*
  $format = xc_format_get($facet->metadata_schema);
  foreach ($format['entities'] as $entity) {
    $_entity = xc_metadata_entity_get($entity);
    $_entity_fields = $_entity->get_fields();
    foreach ($_entity_fields as $_entity_field) {
      $name = $_entity_field->namespace . ':' . $_entity_field->name;
      xc_search_facet_mapping_get_facets($facet->metadata_schema, TRUE),
      $options['select']['name'][$name] = $name;
    }
  }
  */
  
  $form = xc_util_build_autoform($schema, $options);
  drupal_set_title(t('Date-type facet'));
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );
  if (count($options['select']['attribute_set_id']) == 0) {
    $form['attribute_set_id']['#description'] =  l(
      t('There is no date facet attribute set defined. Please create a new set first!'), 
      'xc/search/displaying/facet/datefacetset/add'
    );
  }

  return $form;
}

function xc_search_facet_date_field_edit_form(&$form_state, $field) {
  $facet = xc_search_facet_load($field->facet_id);
  $form = xc_search_facet_date_field_form($form_state, $facet);
  $form['field_id'] = array(
    '#type'  => 'hidden',
    '#value' => $field->field_id,
  );
  $form['name']['#default_value']            = $field->name;
  $form['attibute_set_id']['#default_value'] = $field->attibute_set_id;
  $form['submit']['#value']      = t('Save');
  $form['delete'] = array(
    '#type'  => 'submit',
    '#value' => t('Delete'),
  );

  return $form;
}

function xc_search_facet_date_field_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  $record->name             = $values['name'];
  $record->type             = $values['type'];
  $record->facet_id         = $values['facet_id'];
  $record->attribute_set_id = $values['attribute_set_id'];
  
  $ret_val = drupal_write_record('xc_search_facet_field', $record);
  if ($ret_val == SAVED_NEW) {
    drupal_set_message(t('Successfully added field type facet %name',
      array('%name' => $record->name)));
    $form_state['redirect'] = 'xc/search/displaying/facet/group/' 
      . $record->facet_id . '/view';
  }
  else {
    drupal_set_message(t('Unexpected error. Failed to create new facet.'));
  }
}

function xc_search_facet_date_field_edit_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $record = new stdClass();
  $record->field_id         = $values['field_id'];
  $record->name             = $values['name'];
  $record->type             = $values['type'];
  $record->facet_id         = $values['facet_id'];
  $record->attribute_set_id = $values['attribute_set_id'];
  
  if ($form_state['clicked_button']['#value'] == t('Delete')) {
    $sql = 'DELETE FROM {xc_search_facet_field} WHERE field_id = %d';
    $result = db_query($sql, $record->field_id);

    if ($result == SAVED_DELETED) { // repository is deleted
      drupal_set_message(t('%name removed', array('%name' => $record->name)));
      $form_state['redirect'] = 'xc/search/displaying/facet/group' 
        . $record->facet_id . '/view';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed to remove repository.'));
    }
  }
  else {
    $ret_val = drupal_write_record('xc_search_facet_field', $record, 'field_id');
    if ($ret_val == SAVED_UPDATED) {
      drupal_set_message(t('Successfully updated field type facet %name',
        array('%name' => $record->name)));
      $form_state['redirect'] = 'xc/search/displaying/facet/group/' 
        . $record->facet_id . '/view';
    }
    else {
      drupal_set_message(t('Unexpected error. Failed to create new facet.'));
    }
  }
}
