<?php
// $Id: xc_search_facet_type.php,v 1.1.2.2 2010/03/18 09:25:47 pkiraly Exp $

function xc_search_facet_alias_type() {
  drupal_get_form('xc_search_facet_alias_type_form');
}

function xc_search_facet_alias_get_facet_types() {
  $sql = "SELECT * FROM {xc_search_facet_type}";
  $result = db_query(db_rewrite_sql($sql, '{xc_search_facet_type}', 'facet_type_id'));
  $values = array();
  while ($data = db_fetch_object($result)) {
    $values[$data->facet] = array('id' => $data->facet_type_id, 
      'type' => $data->type);
  }
  return $values;
}

function xc_search_facet_alias_type_form() {
  drupal_set_title('Map facets into a type');
  
  $facets = xc_search_facet_mapping_get_facets(NULL, TRUE);
  $existing_facet_types = xc_search_facet_alias_get_facet_types();
  $types = array('text', 'date', 'number');
  foreach ($facets as $facet_name => $label) {
    $default_type = $types[0];
    if (isset($existing_facet_types[$facet_name])) {
      $default_type = $existing_facet_types[$facet_name]['type'];
      $id = $existing_facet_types[$facet_name]['id'];
      $form['existings']['ex---'.$facet_name] = array(
        '#type' => 'hidden',
        '#value' => $facet_name,
      );
      $form['ids']['ex---'.$facet_name] = array(
        '#type' => 'hidden',
        '#value' => $id,
      );
    }
    foreach ($types as $type) {
      $key = 'type---'.$facet_name;
      $form['types'][$facet_name][$type][$key] = array(
        '#title' => $type,
        '#type' => 'radio',
        '#return_value' => $type, 
      );
      if ($type == $default_type) {
        $form['types'][$facet_name][$type][$key]['#attributes']['checked'] = 'checked';
      }
    }
  }
  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );
  return $form;
}

function theme_xc_search_facet_alias_type_form($form) {
  $output = t('There are thee types of facets: a) the text based field facet, which contains and displays
    regular text b) the date facet, which works on fields stores as dates, and c) the query facets, which 
    regularly works on numeric values. You can map these types to the above storage types. We set the 
    default to text. This list always shows the actual facets, which are mapped to a field. Those 
    facets which still has not mapped to a type are displayed in <font color="red">red</font>.');
  
  $existing_facet_types = xc_search_facet_alias_get_facet_types();
  $rows = array();
  $row = array();
  foreach (element_children($form['types']) as $facet) {
    $row = array((isset($existing_facet_types[$facet]) ? $facet 
      : array('data' => $facet, 'style' => 'color:red')));
    foreach (element_children($form['types'][$facet]) as $type) {
      $row[] = array('data' => drupal_render($form['types'][$facet][$type]));
    }
    $rows[] = $row;
  }
  $header = array(t('facet'), t('field'), t('date'), t('int'));
  $output .= theme('table', $header, $rows);
  $output .= drupal_render($form);
  return $output;
}

function xc_search_facet_alias_type_form_submit($form, &$form_state) {
  $values = $form_state['values'];
  $existing_facet_types = xc_search_facet_alias_get_facet_types();
  
  foreach ($values as $key => $value) {
    if (preg_match('/^type---(.*)$/', $key, $matches)) {
      $record = new stdClass();
      $record->facet = $matches[1];
      $record->type  = $value;
      if (isset($existing_facet_types[$record->facet])) {
        if ($existing_facet_types[$record->facet]['type'] == $record->type) {
          continue;
        } 
        else {
          $record->facet_type_id = $existing_facet_types[$record->facet]['id'];
          $ret_val = drupal_write_record('xc_search_facet_type', $record, 'facet_type_id');
          if ($ret_val == SAVED_UPDATED) {
            drupal_set_message(t('Successfully updated %facet facet as %type type.',
              array('%facet' => $record->facet, '%type' => $record->type)));
          }
          else {
            drupal_set_message(t('Unexpected error. Failed to update facet type.'));
          }
        }
      }
      else {
        $ret_val = drupal_write_record('xc_search_facet_type', $record);
        if ($ret_val == SAVED_NEW) {
          drupal_set_message(t('Successfully registered %facet facet as %type type.',
            array('%facet' => $record->facet, '%type' => $record->type)));
        } 
        else {
          drupal_set_message(t('Unexpected error. Failed to register facet type.'));
        }
      }
    }
  }
  $form_state['redirect'] = 'xc/search/facet_alias/type';
}

