// $Id: xc_search.js,v 1.1.2.12 2010/06/01 21:38:22 pkiraly Exp $

var XCSearch = {};
if(Drupal.jsEnabled) {
  XCSearch.savedItems = 0;
  XCSearch.ncipCounter = 0;
  
  $(document).ready(function(){
    $('#select_all_action').click(function(){
      $('input[name=items]').each(function(){
        if(!this.checked) {
          this.checked = "checked";
        }
      });
    });
    $('#select_none_action').click(function(){
      $('input[name=items]').each(function(){
        if(this.checked) {
          this.checked = false;
        }
      });
    });
    $('#email_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
    });
    $('#print_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
    });
    $('#bookmark_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
      XCSearch.savedItems = selectedItems.length;
      if(selectedItems.length > 0) {
        $('#selection_bar_actions li#notification').text('saving bookmarks...').show();
      }
      for(i in selectedItems) {
        XCSearch.saveItem(selectedItems[i]);
      }
    });

    // iterate over images
    var image_info = Drupal.settings.xc_search.image_info;
    for(node_id in image_info) {
      XCSearch.getImage(node_id, image_info[node_id]);
    }
    
    // iterate over the NCIP information
    var ncip_info = Drupal.settings.xc_search.ncip_info;
    XCSearch.ncipCounter = Drupal.settings.xc_search.ncip_item_count;
    $('#selection_bar_actions li#notification')
      .text('updating availability status information...')
      .show();
    for(ncip_provider_id in ncip_info) {
      for(node_info_id in ncip_info[ncip_provider_id]) {
        for(node_id in ncip_info[ncip_provider_id][node_info_id]) {
          XCSearch.getAvailability(node_id, ncip_provider_id,
            ncip_info[ncip_provider_id][node_info_id][node_id]);
        }
      }
    }

    var node_id = Drupal.settings.xc_search.node_id;
    var ncip_ids = Drupal.settings.xc_search.ncip_ids;
    XCSearch.ncipCounter = Drupal.settings.xc_search.ncip_item_count;
    $('#selection_bar_actions li#notification')
      .text('updating availability status information...')
      .show();
    for(ncip_provider_id in ncip_ids) {
      XCSearch.getAvailabilityAll(node_id, ncip_provider_id, ncip_ids[ncip_provider_id]);
    }
  });
  
  /**
   * Get image URL, and insert it into HTML
   */
  XCSearch.getImage = function(node_id, options) {
    $.get(Drupal.settings.xc_search.image_url, options, function(data){
      syndetics = Drupal.parseJson(data);
      if(syndetics.image_url != "") {
        td = $('#coverart-' + node_id);
        td.html('<img src="' + syndetics.image_url + '">');
      }
    });
  };
  
  /**
   * Get availability information and insert it into HTML
   * @param node_id The node id of the item in a search result list
   * @param ncip_id The NCIP server ID
   * @param bib_id  The bib ID of the item in a search result list
   */
  XCSearch.getAvailability = function(node_id, ncip_id, bib_id) {
    var options = {};
    options.ncip_id = ncip_id;
    options.bib_id  = bib_id;
    $.get(Drupal.settings.xc_search.ncip_url, options, function(data){
      ncip_info = Drupal.parseJson(data);
      if(ncip_info.availability != "") {
        td = $('#xc-availability-' + node_id);
        td.html(ncip_info.availability);
      }
      XCSearch.ncipCounter--;
      if(XCSearch.ncipCounter == 0) {
        $('#selection_bar_actions li#notification')
          .text('All availability status information updated')
          .fadeOut(3000);
      }
    });
  };

  /**
   * Get availability information and insert it into HTML
   * @param node_id The node id of the item in a search result list
   * @param ncip_id The NCIP server ID
   * @param bib_id  The bib ID of the item in a search result list
   */
  XCSearch.getAvailabilityAll = function(node_id, provider_id, bib_ids) {
    var options = {};
    options.provider_id = provider_id;
    options.bib_ids    = bib_ids;
    $.get(Drupal.settings.xc_search.ncip_url, options, function(html_info){
      var table = $('#xc-availability-' + node_id);
      table.hide();
      table.html(html_info).fadeIn(3000);;
    });
  };

  /**
   * Save selecter items
   */
  XCSearch.saveItem = function(id) {
    var options = {'id': id};
    $.get(Drupal.settings.xc_search.save_item_url, options, function(data){
      ncip_info = Drupal.parseJson(data);
      if(ncip_info.availability != "") {
        td = $('#xc-availability-' + node_id);
        td.html(ncip_info.availability);
      }
      XCSearch.savedItems--;
      if(XCSearch.savedItems == 0) {
        $('#selection_bar_actions li#notification')
          .text('All items bookmarked')
          .fadeOut(3000);
      }
    });
  };

  /**
   * Get the selected items in a search result list
   */
  XCSearch.getSelectedItems = function() {
    var selectedItems = [];
    $('input[name=items]').each(function(){
      if(this.checked) {
        selectedItems.push(this.value);
      }
    });
    return selectedItems;
  }
  
  XCSearch.openWorldCatIdentity = function(sURL) {
    $.get(Drupal.settings.xc_search.open_worldcat_identity_url, {'sURL': sURL}, 
        function(data){
      document.location = data.url;
    });
  }

}